--[[
Interface: 1.5.1.0 b6732

Copyright (C) GtX (Andy), 2020

Author: GtX | Andy
Date: 05.05.2020

Contact:
https://forum.giants-software.com
https://github.com/GtX-Andy

History:
V 1.0.0.0 @ 05.05.2020 - Release version

Important:
No changes are to be made to this script without permission from GtX | Andy
An diesem Skript dürfen ohne Genehmigung von GtX | Andy keine Änderungen vorgenommen werden
]]


SetCurrentKeyOwnerEvent = {}

local SetCurrentKeyOwnerEvent_mt = Class(SetCurrentKeyOwnerEvent, Event)
InitEventClass(SetCurrentKeyOwnerEvent, "SetCurrentKeyOwnerEvent")

function SetCurrentKeyOwnerEvent:emptyNew()
    local self = Event:new(SetCurrentKeyOwnerEvent_mt)

    return self
end

function SetCurrentKeyOwnerEvent:new(object, userId, setOffline)
    local self = SetCurrentKeyOwnerEvent:emptyNew()
    self.object = object
    self.userId = userId
    self.setOffline = setOffline

    return self
end

function SetCurrentKeyOwnerEvent:readStream(streamId, connection)
    self.object = NetworkUtil.readNodeObject(streamId)

    if streamReadBool(streamId) then
        self.userId = streamReadInt8(streamId)
    end

    self.setOffline = streamReadBool(streamId)
    self:run(connection)
end

function SetCurrentKeyOwnerEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.object)

    if streamWriteBool(streamId, self.userId ~= nil) then
        streamWriteInt8(streamId, self.userId)
    end

    streamWriteBool(streamId, self.setOffline)
end

function SetCurrentKeyOwnerEvent:run(connection)
    if self.userId ~= nil then
        self.object:addKeyOwner(nil, self.userId, true)
    else
        self.object:removeKeyOwner(self.setOffline, true)
    end

    if not connection:getIsServer() then
        g_server:broadcastEvent(SetCurrentKeyOwnerEvent:new(self.object, self.userId, self.setOffline), nil, connection, self.object)
    end
end
